<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="120px"
      v-loading="formLoading"
    >
      <el-form-item label="技能中文名称" prop="nameCn">
        <el-input v-model="formData.nameCn" placeholder="请输入技能中文名称" />
      </el-form-item>
      <el-form-item label="技能英文名称" prop="nameEn">
        <el-input v-model="formData.nameEn" placeholder="请输入技能英文名称" />
      </el-form-item>
      <!-- <el-form-item label="上级" prop="parentId">
        <el-tree-select
          v-model="formData.parentId"
          :data="skillTree"
          :props="{...defaultProps, label: 'nameCn'}"
          check-strictly
          default-expand-all
          placeholder="请选择上级"
        />
      </el-form-item> -->
      <!-- <el-form-item v-if="show" label="层级" prop="level">
        <el-radio-group v-model="formData.level">
          <el-radio value="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item> -->
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { SkillApi, SkillVO } from '@/api/menduner/system/skill'
// import { defaultProps, handleTree } from '@/utils/tree'

/** 职业技能 表单 */
defineOptions({ name: 'SkillForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  nameCn: undefined,
  nameEn: undefined,
  parentId: 0,
  level: 0
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref
// const skillTree = ref() // 树形结构

/** 打开弹窗 */
const open = async (type: string, id?: number, level?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id && !!level) {
    formLoading.value = true
    try {
      formData.value = await SkillApi.getSkill(id)
    } finally {
      formLoading.value = false
    }
  }
  // await getSkillTree()
  // 添加下级
  if (level === 0) {
    formData.value.level = Number(level) + 1
    formData.value.parentId = id
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as SkillVO
    if (formType.value === 'create') {
      await SkillApi.createSkill(data)
      message.success(t('common.createSuccess'))
    } else {
      await SkillApi.updateSkill(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    nameCn: undefined,
    nameEn: undefined,
    parentId: 0,
    level: 0
  }
  formRef.value?.resetFields()
}

/** 获得职业技能树 */
// const getSkillTree = async () => {
//   skillTree.value = []
//   const data = await SkillApi.getSkillList({})
//   const root: Tree = { id: 0, name: '顶级职业技能', children: [] }
//   root.children = handleTree(data, 'id', 'parentId')
//   skillTree.value = handleTree(data, 'id', 'parentId')
// }
</script>